unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, ToolWin;

type
  TForm1 = class(TForm)
    Splitter1: TSplitter;
    Panel1: TPanel;
    ListView1: TListView;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Splitter2: TSplitter;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    Savetofile1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    HeaderInfo1: TMenuItem;
    MessageAtributes1: TMenuItem;
    ToolButton3: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure Savetofile1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure HeaderInfo1Click(Sender: TObject);
    procedure MessageAtributes1Click(Sender: TObject);
  private
    { Private declarations }
    dbxfile: String;
    FolderList: TList;
    MessageList: TList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses uoexpress;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  x:integer;
  pfolder: Poe5_FolderInfo;
begin
  dbxfile:='folders.dbx';
  FolderList:=TList.Create;
  MessageList:=TList.Create;
  Read_OE_File(dbxfile, FolderList);
  ListBox1.Items.Clear;
  if FolderList.Count > 0 then
    for x:=0 to FolderList.Count-1 do begin
      pfolder:=FolderList.Items[x];
      ListBox1.Items.Add(pfolder^.FolderName);
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MessageList.Free;
  FolderList.Free;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  pfolder: Poe5_FolderInfo;
  x: integer;
  pmessage: Poe5_MessageInfo;
  ListItem: TListItem;
begin
  pfolder:=FolderList.Items[ListBox1.ItemIndex];
  dbxfile:=pfolder^.FolderFile;
  MessageList.Clear;
  RichEdit1.Clear;
  ListView1.Items.Clear;

  if dbxfile<>'' then
    Read_OE_File(dbxfile, MessageList);
  if MessageList.Count>0 then begin
    for x:=0 to MessageList.Count-1 do begin
      pmessage:=MessageList.Items[x];
      ListItem:= ListView1.Items.Add;
      ListItem.Caption:= pmessage^.From;
      ListItem.SubItems.Add(pmessage^.Receipt);
      ListItem.SubItems.Add(pmessage^.Subject);
      ListItem.SubItems.Add(DateTimeToStr(FiletimeToDatetime(pmessage^.Received)));
      ListItem.SubItems.Add(IntToStr(pmessage^.Position));
      ListItem.SubItems.Add(IntToStr(pmessage^.Size));
    end;
  end;

end;

procedure TForm1.ListView1Click(Sender: TObject);
var
  str: WideString;
  x: longint;
begin
  RichEdit1.Clear;
  x:=Poe5_MessageInfo(MessageList.Items[ListView1.Selected.Index])^.position;
  Read_OE_Message(dbxfile, x, str);
  RichEdit1.Lines.Add(str);
  ToolButton1.Enabled:=(trim(RichEdit1.Text)<>'');
end;

procedure TForm1.Savetofile1Click(Sender: TObject);
begin
  if ListView1.Items.Count > 0 then begin
    ListView1Click(Self);
    if Trim(RichEdit1.Text)<>'' then begin
      SaveDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
      if SaveDialog1.Execute then
        RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
    end;
  end;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  Savetofile1.Enabled := RichEdit1.Lines.Count > 0;
end;

procedure TForm1.HeaderInfo1Click(Sender: TObject);
var
  str: WideString;
  x: longint;
begin
  RichEdit1.Clear;
  x:=Poe5_MessageInfo(MessageList.Items[ListView1.Selected.Index])^.HeaderPosition;
  str:= 'Current header position is: '+IntToStr(x)+#10+#10;
  ReadHeaderInfo(dbxfile, x, str);
  RichEdit1.Lines.Add(str);
end;

procedure TForm1.MessageAtributes1Click(Sender: TObject);
var
  str: WideString;
  x: longint;
begin
  RichEdit1.Clear;
  str:='';
  x:=Poe5_MessageInfo(MessageList.Items[ListView1.Selected.Index])^.MsgFlags;
  if (x and NEWS_MSG) <> 0 then str:=str+'NEWS MESSAGE'+#10;
  if (x and DOWNLOAD_LATER) <> 0 then str:=str+'DOWNLOAD LATER'+#10;
  if (x and DOWNLOADED) <> 0 then str:=str+'DOWNLOADED'+#10;
  if (x and READED) <> 0 then str:=str+'READED'+#10;
  if (x and MARKED) <> 0 then str:=str+'MARKED'+#10;
  if (x and ATTACHMENTS) <> 0 then str:=str+'ATTACHMENTS'+#10;
  if (x and REPLY) <> 0 then str:=str+'REPLY'+#10;
  if (x and INSPECT_CONVERSATION) <> 0 then str:=str+'INSPECT CONVERSATION';
  if (x and IGNORE_CONVERSATION) <> 0 then str:=str+'IGNORE CONVERSATION';
  //if (x and IMPORTED) <> 0 then str:=str+'IMPORTED'+#10;
  RichEdit1.Lines.Add(str);
end;

end.
